| TagLib 1.13 |  |

Public Member Functions | Static Public Member Functions | Protected Member Functions | Friends | List of all members
TagLib::ID3v2::TextIdentificationFrame Class Reference

An ID3v2 text identification frame implementation. More...

`#include <textidentificationframe.h>`

Inheritance diagram for TagLib::ID3v2::TextIdentificationFrame:
[legend]
Collaboration diagram for TagLib::ID3v2::TextIdentificationFrame:
[legend]

## Public Member Functions
| TextIdentificationFrame (const ByteVector &type, String::Type encoding)
| TextIdentificationFrame (const ByteVector &data)
virtual | ~TextIdentificationFrame ()
void | setText (const StringList &l)
virtual void | setText (const String &s)
virtual String | toString () const
String::Type | textEncoding () const
void | setTextEncoding (String::Type encoding)
StringList | fieldList () const
PropertyMap | asProperties () const
Public Member Functions inherited from TagLib::ID3v2::Frame
virtual | ~Frame ()
ByteVector | frameID () const
unsigned int | size () const
void | setData (const ByteVector &data)
virtual void | setText (const String &text)
virtual String | toString () const =0
ByteVector | render () const
TAGLIB_DEPRECATED | Header (const ByteVector &data, bool synchSafeInts)
| Header (const ByteVector &data, unsigned int version=4)
virtual | ~Header ()
TAGLIB_DEPRECATED void | setData (const ByteVector &data, bool synchSafeInts)
void | setData (const ByteVector &data, unsigned int version=4)
ByteVector | frameID () const
void | setFrameID (const ByteVector &id)
unsigned int | frameSize () const
void | setFrameSize (unsigned int size)
unsigned int | version () const
void | setVersion (unsigned int version)
bool | tagAlterPreservation () const
void | setTagAlterPreservation (bool discard)
bool | fileAlterPreservation () const
bool | readOnly () const
bool | groupingIdentity () const
bool | compression () const
bool | encryption () const
bool | unsynchronisation () const
bool | dataLengthIndicator () const
ByteVector | render () const
TAGLIB_DEPRECATED bool | frameAlterPreservation () const

## Static Public Member Functions
static TextIdentificationFrame * | createTIPLFrame (const PropertyMap &properties)
static TextIdentificationFrame * | createTMCLFrame (const PropertyMap &properties)
static const KeyConversionMap & | involvedPeopleMap ()
Static Public Member Functions inherited from TagLib::ID3v2::Frame
static Frame * | createTextualFrame (const String &key, const StringList &values)
static unsigned int | headerSize ()
static unsigned int | headerSize (unsigned int version)
static ByteVector | textDelimiter (String::Type t)
static unsigned int | size ()
static unsigned int | size (unsigned int version)

## Protected Member Functions
virtual void | parseFields (const ByteVector &data)
virtual ByteVector | renderFields () const
| TextIdentificationFrame (const ByteVector &data, Header *h)
Protected Member Functions inherited from TagLib::ID3v2::Frame
| Frame (const ByteVector &data)
| Frame (Header *h)
Header * | header () const
void | setHeader (Header *h, bool deleteCurrent=true)
void | parse (const ByteVector &data)
virtual void | parseFields (const ByteVector &data)=0
virtual ByteVector | renderFields () const =0
ByteVector | fieldData (const ByteVector &frameData) const
String | readStringField (const ByteVector &data, String::Type encoding, int *position=0)
String::Type | checkTextEncoding (const StringList &fields, String::Type encoding) const
PropertyMap | asProperties () const

## Friends
class | FrameFactory

## Additional Inherited Members
Static Public Attributes inherited from TagLib::ID3v2::Frame
static const String | instrumentPrefix
static const String | commentPrefix
static const String | lyricsPrefix
static const String | urlPrefix
Static Protected Member Functions inherited from TagLib::ID3v2::Frame
static String::Type | checkEncoding (const StringList &fields, String::Type encoding)
static String::Type | checkEncoding (const StringList &fields, String::Type encoding, unsigned int version)
static ByteVector | keyToFrameID (const String &)
static String | frameIDToKey (const ByteVector &)
static String | keyToTXXX (const String &)
static String | txxxToKey (const String &)
static void | splitProperties (const PropertyMap &original, PropertyMap &singleFrameProperties, PropertyMap &tiplProperties, PropertyMap &tmclProperties)

## Detailed Description

An ID3v2 text identification frame implementation.

This is an implementation of the most common type of ID3v2 frame – text identification frames. There are a number of variations on this. Those enumerated in the ID3v2.4 standard are:

- TALB Album/Movie/Show title
- TBPM BPM (beats per minute)
- TCOM Composer
- TCON Content type
- TCOP Copyright message
- TDEN Encoding time
- TDLY Playlist delay
- TDOR Original release time
- TDRC Recording time
- TDRL Release time
- TDTG Tagging time
- TENC Encoded by
- TEXT Lyricist/Text writer
- TFLT File type
- TIPL Involved people list
- TIT1 Content group description
- TIT2 Title/songname/content description
- TIT3 Subtitle/Description refinement
- TKEY Initial key
- TLAN Language(s)
- TLEN Length
- TMCL Musician credits list
- TMED Media type
- TMOO Mood
- TOAL Original album/movie/show title
- TOFN Original filename
- TOLY Original lyricist(s)/text writer(s)
- TOPE Original artist(s)/performer(s)
- TOWN File owner/licensee
- TPE1 Lead performer(s)/Soloist(s)
- TPE2 Band/orchestra/accompaniment
- TPE3 Conductor/performer refinement
- TPE4 Interpreted, remixed, or otherwise modified by
- TPOS Part of a set
- TPRO Produced notice
- TPUB Publisher
- TRCK Track number/Position in set
- TRSN Internet radio station name
- TRSO Internet radio station owner
- TSOA Album sort order
- TSOP Performer sort order
- TSOT Title sort order
- TSRC ISRC (international standard recording code)
- TSSE Software/Hardware and settings used for encoding
- TSST Set subtitle

The ID3v2 Frames document gives a description of each of these formats and the expected order of strings in each. ID3v2::Header::frameID() can be used to determine the frame type.

Note
  If non-Latin1 compatible strings are used with this class, even if the text encoding is set to Latin1, the frame will be written using UTF8 (with the encoding flag appropriately set in the output).

## Constructor & Destructor Documentation

## ◆ TextIdentificationFrame() [1/3]

TagLib::ID3v2::TextIdentificationFrame::TextIdentificationFrame | ( | const ByteVector & | type,
|  | String::Type | encoding
| ) |  |

Construct an empty frame of type type. Uses encoding as the default text encoding.

Note
  In this case you must specify the text encoding as it resolves the ambiguity between constructors.
  Please see the note in the class description regarding Latin1.

## ◆ TextIdentificationFrame() [2/3]

TagLib::ID3v2::TextIdentificationFrame::TextIdentificationFrame | ( | const ByteVector & | data | ) |
| explicit

This is a dual purpose constructor. data can either be binary data that should be parsed or (at a minimum) the frame ID.

## ◆ ~TextIdentificationFrame()

virtual TagLib::ID3v2::TextIdentificationFrame::~TextIdentificationFrame | ( |  | ) |
| virtual

Destroys this TextIdentificationFrame instance.

## ◆ TextIdentificationFrame() [3/3]

TagLib::ID3v2::TextIdentificationFrame::TextIdentificationFrame | ( | const ByteVector & | data,
|  | Header * | h
| ) |  |
| protected

The constructor used by the FrameFactory.

## Member Function Documentation

## ◆ asProperties()

PropertyMap TagLib::ID3v2::TextIdentificationFrame::asProperties | ( |  | ) | const

## ◆ createTIPLFrame()

static TextIdentificationFrame * TagLib::ID3v2::TextIdentificationFrame::createTIPLFrame | ( | const PropertyMap & | properties | ) |
| static

This is a special factory method to create a TIPL (involved people list) frame from the given properties. Will parse key=[list of values] data into the TIPL format as specified in the ID3 standard.

## ◆ createTMCLFrame()

static TextIdentificationFrame * TagLib::ID3v2::TextIdentificationFrame::createTMCLFrame | ( | const PropertyMap & | properties | ) |
| static

This is a special factory method to create a TMCL (musician credits list) frame from the given properties. Will parse key=[list of values] data into the TMCL format as specified in the ID3 standard, where key should be of the form instrumentPrefix:instrument.

## ◆ fieldList()

StringList TagLib::ID3v2::TextIdentificationFrame::fieldList | ( |  | ) | const

Returns a list of the strings in this frame.

## ◆ involvedPeopleMap()

static const KeyConversionMap & TagLib::ID3v2::TextIdentificationFrame::involvedPeopleMap | ( |  | ) |
| static

Returns a KeyConversionMap mapping a role as it would be used in a PropertyMap to the corresponding key used in a TIPL ID3 frame to describe that role.

## ◆ parseFields()

virtual void TagLib::ID3v2::TextIdentificationFrame::parseFields | ( | const ByteVector & | data | ) |
| protected virtual

Called by parse() to parse the field data. It makes this information available through the public API. This must be overridden by the subclasses.

Implements TagLib::ID3v2::Frame.

## ◆ renderFields()

virtual ByteVector TagLib::ID3v2::TextIdentificationFrame::renderFields | ( |  | ) | const
| protected virtual

Render the field data back to a binary format in a ByteVector. This must be overridden by subclasses.

Implements TagLib::ID3v2::Frame.

## ◆ setText() [1/2]

virtual void TagLib::ID3v2::TextIdentificationFrame::setText | ( | const String & | text | ) |
| virtual

Set the text of frame in the sanest way possible. This should only be reimplemented in frames where there is some logical mapping to text.

Note
  If the frame type supports multiple text encodings, this will not change the text encoding of the frame; the string will be converted to that frame's encoding. Please use the specific APIs of the frame types to set the encoding if that is desired.

Reimplemented from TagLib::ID3v2::Frame.

Reimplemented in TagLib::ID3v2::UserTextIdentificationFrame.

## ◆ setText() [2/2]

void TagLib::ID3v2::TextIdentificationFrame::setText | ( | const StringList & | l | ) |

Text identification frames are a list of string fields.

This function will accept either a StringList or a String (using the StringList constructor that accepts a single String).

Note
  This will not change the text encoding of the frame even if the strings passed in are not of the same encoding. Please use setEncoding(s.type()) if you wish to change the encoding of the frame.

## ◆ setTextEncoding()

void TagLib::ID3v2::TextIdentificationFrame::setTextEncoding | ( | String::Type | encoding | ) |

Sets the text encoding to be used when rendering this frame to encoding.

Note
  Please see the note in the class description regarding Latin1.

See also
  textEncoding()
  render()

## ◆ textEncoding()

String::Type TagLib::ID3v2::TextIdentificationFrame::textEncoding | ( |  | ) | const

Returns the text encoding that will be used in rendering this frame. This defaults to the type that was either specified in the constructor or read from the frame when parsed.

Note
  Please see the note in the class description regarding Latin1.

See also
  setTextEncoding()
  render()

## ◆ toString()

virtual String TagLib::ID3v2::TextIdentificationFrame::toString | ( |  | ) | const
| virtual

This returns the textual representation of the data in the frame. Subclasses must reimplement this method to provide a string representation of the frame's data.

Implements TagLib::ID3v2::Frame.

Reimplemented in TagLib::ID3v2::UserTextIdentificationFrame.

## Friends And Related Function Documentation

## ◆ FrameFactory

friend class FrameFactory
| friend

The documentation for this class was generated from the following file:

- textidentificationframe.h